using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using SvetoforVKBot.Models.Updates;
using VkNet;
using VkNet.Enums.SafetyEnums;
using VkNet.Model.Keyboard;
using VkNet.Model.RequestParams;
using System.Linq;

namespace SvetoforVKBot.Models.Commands.Registration
{
    public class GetFIOCommand
    {
        public void Execute(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
            var chatId = update.@object.message.from_id;
            MessagesSendParams @params = new MessagesSendParams();
            var keyboardBuilder = new KeyboardBuilder().Clear();
            int i = 0;
            int btnCount = 0;
            int btnLines = 0;
            int startYear = DateTime.Now.Year - 18;

            try
            {                
                if (update.@object.message.text.Length > 0 && update.@object.message.text.Length <= 50)
                {
                    var ids = new long[] { chatId };

                    var user = db.Users.Single(usr => usr.chatId == chatId);
                    user.fio = update.@object.message.text.Trim();
                    user.tag = "Подписчик - Регистрация - ДР - Год";
                    db.SaveChanges();

                    //editUser.Parameters.AddWithValue("@tag", "Подписчик - Регистрация - ДР - Год");

                    
                    for (i = startYear; i > startYear - 20; i--)
                    {
                        keyboardBuilder
                            .AddButton(i.ToString(), i.ToString(), KeyboardButtonColor.Primary);

                        btnCount++;

                        if (btnCount % 4 == 0)
                        {
                            btnLines++;
                            keyboardBuilder.AddLine();
                        }
                    }

                    if (btnCount % 4 != 0)
                    {
                        keyboardBuilder.AddLine();
                    }

                    keyboardBuilder
                        .AddButton("Отменить", "startPL", KeyboardButtonColor.Default);

                    @params.Keyboard = keyboardBuilder
                        .Build();

                    @params.Message = "Отлично! Теперь выберите на клавиатуре внизу или введите свой год рождения, например 1993. \n";
                    @params.UserId = chatId;
                    @params.RandomId = GetRandomId();
                    client.Messages.SendAsync(@params);
                }
                else
                {
                    @params.Message = "Данные введены некорректно 😕 Напишите, пожалуйста, текст длиной до 50 символов.";
                    @params.UserId = chatId;
                    @params.RandomId = GetRandomId();
                    client.Messages.SendAsync(@params);
                }
            }
            catch (Exception ee)
            {
                @params.Message = "‼Ошибка в GetFIOCommand: " + ee.Message;
                @params.Attachments = null;
                @params.Keyboard = null;
                @params.UserId = 59111081;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
        }

        private static readonly RandomNumberGenerator Rng = RandomNumberGenerator.Create();
        public int GetRandomId()
        {
            var intBytes = new byte[4];

            Rng.GetBytes(intBytes);

            return BitConverter.ToInt32(intBytes, 0);
        }
    }
}